This README is the main source of information on dtfinder and related technology.
Here you will find two main tools available. The dtfinder, which stands for Decision Tree Finder, and the sddtfinder, which stands for Smallest Depth Decision Tree Finder.
The objective of dtfinder is to search for a decision tree with the smallest number of nodes in the tree that is consistent wiht the given input.
The objective of sddtfinder is also to search for a decision tree consistent with the given input, but whose nodes have the smallest depth possible. In case there are more than one such trees, than sddtfinder reports a tree with the smallest number of nodes possible.

A) Publications/Citations:

- "SAT-based Encodings for Optimal Decision Trees with Explicit Paths", Mikolas Janota, Antonio Morgado, SAT, 2020

B) Pre-requisites:

- PySAT: SAT technology in Python, https://github.com/pysathq/pysat
- Scikit-learn: Machine learning in Python, https://scikit-learn.org

C) Directory structure:

 The dtfinder source directory contains 3 sub-directories:
	- dtfinder, containing the source code of both dtfinder and sddtfinder
	- greedy, containing the source code for obtaining greedy solutions using Scikit-learn
	- scripts, contain the code for enumerating topologies

 The main starting point file for dtfinder is the file dtfinder/dtfinder. To obtain all the  options available in dtfinder use:
 
    $ dtfinder -h

The main starting point file for sddtfinder is the file dtfinder/sddtfinder. To obtain all the options available in sddtfinder use:

    $ sddtfinder -h
    
D) License:
        
dtfinder is realeased under the GNU GPL version 3 of the License (or higher).
